#
# This file contains rules which are shared between multiple Makefiles.
#

# Every thing starts here
# 

default:all

# Define Variables
include $(TOPDIR)/Vars.make 

#
# False targets.
#
.PHONY: dummy

#
# Special variables which should not be exported
#
unexport EXTRA_AFLAGS
unexport EXTRA_CFLAGS
unexport EXTRA_LDFLAGS
unexport EXTRA_ARFLAGS
unexport SUBDIRS
unexport SUB_DIRS
unexport ALL_SUB_DIRS
unexport MOD_SUB_DIRS
unexport O_TARGET
unexport ALL_MOBJS

unexport obj-y
unexport obj-m
unexport obj-n
unexport obj-
unexport export-objs
unexport subdir-y
unexport subdir-m
unexport subdir-n
unexport subdir-

#
# Get things started.
#

first_rule: sub_dirs
	$(MAKE) all_targets

%.s: %.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(CFLAGS_$@) -S $< -o $@

%.i: %.c
	$(CPP) $(CFLAGS) $(EXTRA_CFLAGS) $(CFLAGS_$@) $< > $@

%.o: %.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(CFLAGS_$@) -c $< -o $@

%.o: %.s
	$(AS) $(AFLAGS) $(EXTRA_CFLAGS) -o $@ $<

%.s: %.S
	$(CPP) $(AFLAGS) $(EXTRA_AFLAGS) $(AFLAGS_$@) $< > $@

%.o: %.S
	$(CC) $(AFLAGS) $(EXTRA_AFLAGS) $(AFLAGS_$@) -c -o $@ $<


define make_subdirs
	actual_dir=$$( pwd ); \
	for dir in $(SUBDIRS); do \
		echo Entering $$actual_dir/$$dir; \
		$(MAKE) -C $$dir $@ || exit 1 ; \
	done
endef

define set_config_var
	sed 's/^$(strip $(subst /,\/,$(subst ','\'',$(2))))=.*$$/$(strip $(subst /,\/,$(subst ','\'',$(2))))=$(strip $(subst /,\/,$(subst ','\'',$(3))))/' $(1) > $(1).tmp && mv $(1).tmp $(1)
endef

# $( not_$(CONFIG)) = y if CONFIG is n or ''
export not_    = y
export not_n   = y

export y_and_y = y

export y_or_y  = y
export y_or_   = y
export y_or_n  = y
export  _or_y  = y
export n_or_y  = y

.PHONY: test test-setup test-teardown
test:
test-setup:
test-teardown:

